#include "oobject.ch"

#translate GETSET( <xVal>, <xParm> ) => ;
           <xVal> := IF( <xParm> == NIL, <xVal>, <xVal> := <xParm>)


/****
*
*     Replacement for the TBColumn Class class.
*     Can be inherited using the oobject.lib
*
*     Note:
*     -----
*     This code is 5.3 specific. To convert it to 5.2 erase the 5.3 methods
*     and IVars from the class.
*
*/

// Shell function
/*---------------------------------------------------------------------------*/
FUNCTION DBColumnNew(cHead, bData)
/*---------------------------------------------------------------------------*/
Local oCol := oTBColumn():TBColumnNew(cHead, bData)
Return oCol


//------------------------------------------------------  CLASS INIT
CLASS oTBColumn

DATA oCol

METHOD  TBColumnNew    = _oNewCol
METHOD  block          = _oCBlock
METHOD  cargo          = _oCCargo
METHOD  colorBlock     = _oCColorBlock
METHOD  colSep         = _oCColSep
METHOD  defColor       = _oCDefColor
METHOD  footing        = _oCFooting
METHOD  footSep        = _oCFootSep
METHOD  heading        = _oCHeading
METHOD  headSep        = _oCHeadSep
METHOD  picture        = _oCPicture
METHOD  postBlock      = _oCPostBlock
METHOD  preBlock       = _oCPreBlock
METHOD  width          = _oCWidth

METHOD  _block         = _oCBlock
METHOD  _cargo         = _oCCargo
METHOD  _colorBlock    = _oCColorBlock
METHOD  _colSep        = _oCColSep
METHOD  _defColor      = _oCDefColor
METHOD  _footing       = _oCFooting
METHOD  _footSep       = _oCFootSep
METHOD  _heading       = _oCHeading
METHOD  _headSep       = _oCHeadSep
METHOD  _picture       = _oCPicture
METHOD  _postBlock     = _oCPostBlock
METHOD  _preBlock      = _oCPreBlock
METHOD  _width         = _oCWidth
METHOD  setstyle       = _oCSetStyle     // 5.3

ENDCLASS


//------------------------------------------------------  CONSTRUCTOR
CONSTRUCTOR _oNewCol(x,y)
::oCol := TbColumnNew( x,y )
Return(self)

//------------------------------------------------------  DATA
METHOD FUNCTION _oCblock(x)
return( GETSET( ::oCol:block, x ))

METHOD FUNCTION  _oCcargo(x)
return( GETSET( ::oCol:cargo, x ))

METHOD FUNCTION  _oCcolorBlock(x)
return( GETSET( ::oCol:colorblock, x ))

METHOD FUNCTION  _oCcolSep(x)
return( GETSET( ::oCol:colsep, x ))

METHOD FUNCTION  _oCdefColor(x)
return( GETSET( ::oCol:defcolor, x ))

METHOD FUNCTION  _oCfooting(x)
return( GETSET( ::oCol:footing, x ))

METHOD FUNCTION  _oCfootSep(x)
return( GETSET( ::oCol:footsep, x ))

METHOD FUNCTION  _oCheading(x)
return( GETSET( ::oCol:heading, x ))

METHOD FUNCTION  _oCheadSep(x)
return( GETSET( ::oCol:headsep, x ))

METHOD FUNCTION  _oCpicture(x)
return( GETSET( ::oCol:picture, x ))

METHOD FUNCTION  _oCpostBlock(x)
return( GETSET( ::oCol:postblock, x ))

METHOD FUNCTION  _oCpreBlock(x)
return( GETSET( ::oCol:preblock, x ))

METHOD FUNCTION  _oCwidth(x)
return( GETSET( ::oCol:width, x ))

//------------------------------------------------------  METHODS
METHOD FUNCTION _oCsetstyle(x, y)
return( ::oCol:SetStyle(x, y) )
