#include "oobject.ch"

/****
*
*     Replacement for the 5.3 PushButton class.
*     Can be inherited using the oobject.lib
*/



/*---------------------------------------------------------------------------*/
FUNCTION oPButtonNew(nRow, nCol, cCaption)
/*---------------------------------------------------------------------------*/
Local oButt := oPushButton():PushButton(nRow, nCol, cCaption)
Return( oButt )


//------------------------------------------------------  CLASS INIT
CLASS  oPushButton

DATA   oButton
METHOD PushButton  = _oCBPushNew
METHOD buffer      = _oCBBuffer
METHOD caption     = _oCBCaption
METHOD cargo       = _oCBCargo
METHOD col         = _oCBCol
METHOD colorSpec   = _oCBColorSpec
METHOD fBlock      = _oCBFBlock
METHOD hasFocus    = _oCBHasFocus
METHOD message     = _oCBMessage
METHOD row         = _oCBRow
METHOD sBlock      = _oCBSBlock
METHOD style       = _oCBStyle
METHOD typeOut     = _oCBTypeOut

METHOD _buffer     = _oCBBuffer
METHOD _caption    = _oCBCaption
METHOD _cargo      = _oCBCargo
METHOD _col        = _oCBCol
METHOD _colorSpec  = _oCBColorSpec
METHOD _fBlock     = _oCBFBlock
METHOD _hasFocus   = _oCBHasFocus
METHOD _message    = _oCBMessage
METHOD _row        = _oCBRow
METHOD _sBlock     = _oCBSBlock
METHOD _style      = _oCBStyle
METHOD _typeOut    = _oCBTypeOut

METHOD display     = _oCBDisplay
METHOD hitTest     = _oCBHitTest
METHOD killFocus   = _oCBKillFocus
METHOD select      = _oCBSelect
METHOD setFocus    = _oCBSetFocus

ENDCLASS


//------------------------------------------------------  CONSTRUCTOR
CONSTRUCTOR _oCBPushNew(x,y,z)
::oButton := PushButton(x,y,z)
Return( self )


//------------------------------------------------------  DATA
METHOD FUNCTION _oCBBuffer(x)
Return( GETSET( ::oButton:Buffer, x ) )

METHOD FUNCTION _oCBCaption(x)
Return( GETSET( ::oButton:Caption, x ) )

METHOD FUNCTION _oCBCargo(x)
Return( GETSET( ::oButton:Cargo, x ) )

METHOD FUNCTION _oCBCol(x)
Return( GETSET( ::oButton:Col, x ) )

METHOD FUNCTION _oCBColorSpec(x)
Return( GETSET( ::oButton:ColorSpec, x ) )

METHOD FUNCTION _oCBFBlock(x)
Return( GETSET( ::oButton:FBlock, x ) )

METHOD FUNCTION _oCBHasFocus(x)
Return( GETSET( ::oButton:HasFocus, x ) )

METHOD FUNCTION _oCBMessage(x)
Return( GETSET( ::oButton:Message, x ) )

METHOD FUNCTION _oCBRow(x)
Return( GETSET( ::oButton:Row, x ) )

METHOD FUNCTION _oCBSBlock(x)
Return( GETSET( ::oButton:SBlock, x ) )

METHOD FUNCTION _oCBStyle(x)
Return( GETSET( ::oButton:Style, x ) )

METHOD FUNCTION _oCBTypeOut(x)
Return( GETSET( ::oButton:TypeOut, x ) )



//------------------------------------------------------  METHODS
METHOD FUNCTION _oCBDisplay()
RETURN( ::oButton:Display() )

METHOD FUNCTION _oCBHitTest(x,y)
RETURN( ::oButton:HitTest(x,y) )


METHOD FUNCTION _oCBKillFocus()
RETURN( ::oButton:KillFocus() )


METHOD FUNCTION _oCBSelect(x)
RETURN( ::oButton:Select(x) )


METHOD FUNCTION _oCBSetFocus()
RETURN( ::oButton:SetFocus() )

