#include "Manos.ch"
#include "oObject.ch"

/****
*
*      oStatBar.prg
*      oObject Class Demonstration.
*
*      Notes:
*      ------
*      An all purpose Status Bar for indexing etc.
*      The bar inside can be either opaque or transparent ( like in windows )
*      so you can see the underlying characters.
*/

#define SB_OPAQUE               1
#define SB_TRANSPARENT          2

#ifdef TEST
Proc Test()
local i
Local oBar1 := StatBar():New( 0, 100, 10, "Test StatBar 1", "w+/r" )
Local oBar2 := StatBar():New( 0, 100, 15, "Test StatBar 2", "b/bg" )
oBar2:Style := 1
For i=1 TO 100
   oBar1:update(i)
   oBar2:update(i)
   inkey(0)
next

oBar1:Clear()
oBar2:Clear()
For i=1 TO 100
   oBar1:update(i)
   oBar2:update(i)
   inkey(.05)
next

oBar1:remove()
oBar2:remove()
#endif


//

CLASS StatBar

DATA nBarRow        AS 10
DATA cColor         AS "N/BG"
DATA cProgColor     AS "W/B"
DATA cTitle
DATA Style          := SB_TRANSPARENT
DATA nMaxRow        := 0
DATA nTotalSize     := 0

LOCAL:
DATA aSave
DATA nMaxCol        := MaxCol()
DATA nMaxLen        AS MaxCol()-20
DATA cScrn

EXPORT:
METHOD New( nBytes, nSize, nDispRow, cTitle, cColor )
METHOD Update( nBytes )
METHOD Clear( nTotal, cTitle )
METHOD Remove()
METHOD Reset( n )  INLINE ::Clear( n )

ENDCLASS



//
METHOD New( nBytes, nSize, nDispRow, cTitle, cColor )
//
DEFAULT nDispRow := 10
DEFAULT nBytes   := 0
DEFAULT cColor   := "N/BG"
 ::aSave         := { SetCursor(0), Row(), Col(), SetColor() }
 ::cColor        := cColor
 ::nMaxRow       := if( nDispRow == NIL , MaxRow( ) , nDispRow + 4 )
 ::nTotalSize    := if( nSize == NIL, 0, nSize )
 ::nBarRow       := nDispRow
 ::cTitle        := cTitle
 ::cScrn         := SaveScreen( ::nMaxRow -4, 10 , ::nMaxRow - 1, ;
                                ::nMaxCol - 10 + 2 )

 BoxShadow( ::nMaxRow -4, 10 , ::nMaxRow - 2, ::nMaxCol - 10)
 DispBox(   ::nMaxRow -4, 10 , ::nMaxRow - 2,::nMaxCol - 10, B_SIMPLE+" ", ;
            ::cColor )

 ::cTitle := "["+cTitle+"]"
 ::Clear()

RETURN self


//
METHOD Clear( nTotSize, cTitle )
//
 Local i, nInc:=0, nPos:= 0

 DispBegin()

 ::nTotalSize := IF( nTotSize == NIL, ::nTotalSize, nTotSize )
 ::cTitle     := IF( cTitle == NIL, ::cTitle, cTitle )

 DispBox( ::nMaxRow -4, 10 , ::nMaxRow - 2,::nMaxCol - 10, B_SIMPLE+" ", ;
          ::cColor )

 nInc := ::nMaxLen / 11
 nPos += nInc

 for i := 1 to 9
   DispOutAt( ::nMaxRow - 3, 11+nPos, ;
              STR( i*10, 2 ) + '%', ;
              ::cColor )
   nPos += nInc
 next

 DispOutAt(::nBarRow, maxcol() / 2 - ( len( ::cTitle ) / 2 ), ;
           :: cTitle, ::cColor )
 DispEnd()
RETURN self


//
METHOD Update( nBytes )
//
Local nReplicate, cTmpsave
 IF nBytes <= ::nTotalSize
   DispBegin()

   nReplicate := ( ::nMaxCol - 21 ) * ( nBytes / ::nTotalSize )
   SetPos( ::nMaxRow - 3, 11 )

   IF ::Style == SB_OPAQUE
      DevOut( replicate( '', nReplicate  ), ::cProgColor )
   ELSE
      cTmpSave := SaveScreen(row(),11,Row(), 11+nReplicate-1 )
      RestScreen( Row(), 11, ;
                  Row(), 11+nReplicate-1, ;
                  TRANSFORM( cTmpSave, REPLICATE("X"+CHR( FT_Color2N(::cProgColor) ), LEN( cTmpSave ) )))
   ENDIF

   DispEnd()

 ENDIF

RETURN self


//
METHOD Remove()
//
 RestScreen( ::nMaxRow -4, 10, ::nMaxRow - 1, ::nMaxCol - 10 + 2, ;
             ::cScrn )
 ::cColor := NIL
 ::nMaxRow      := NIL
 ::nTotalSize   := NIL
 SetColor( ::aSave[4] )
 SetPos( ::aSave[2], ::aSave[3] )
 SetCursor( ::aSave[1] )

RETURN self
