#include "oObject.ch"
#include "inkey.ch"
#include "button.ch"

/****
*
*      Scrolbar.prg
*      oObject Class Demonstration.
*
*      Notes:
*      ------
*      An all purpose Scroll Bar.
*      Can be more than one column in width. Other than that it is a direct
*      adaptation of Clipper's SAMPLES\Scrolbar.prg with some enhancements.
*/

#define SB_VERTICAL      1
#define SB_HORIZONTAL    2

#ifdef TEST

PROC test()
Local i, nKey, nInc
Local m := MInit()
Local o := ScrollBar():New( 10,10,20,"w+/b",1)

     o:cFill    := ""
     o:cThumb   := ""
     o:cUpArrow := "/\"
     o:cDnArrow := "\/"
     cls
     o:display():Update( 1, 100, .T. )

     FOR i=1 TO 100
        dispoutat(10,20,i)
        o:Update( i,100,.t.)
        inkey(.5)
     NEXT

     o:display():Update( 1, 100, .T. )
     nInc := 0

     WHILE .T.

       nKey := INKEY(0, INKEY_ALL)

       IF nKey == K_LBUTTONDOWN
         @ 3,0 say o:HitTest()

         IF o:HitTest() == HTSCROLLUNITINC
            nInc+=1
            @1,0 say "HTSCROLLUNITINC  "

         ELSEIF o:HitTest() == HTSCROLLUNITDEC
            nInc -= 1
            @1,0 say "HTSCROLLUNITDEC  "

         ELSEIF o:HitTest() == HTSCROLLBLOCKINC
            nInc += 10
            @1,0 say "HTSCROLLBLOCKINC "

         ELSEIF o:HitTest() == HTSCROLLBLOCKDEC
            nInc -= 10
            @1,0 say "HTSCROLLBLOCKDEC "

         ELSEIF o:HitTest() == HTSCROLLTHUMBDRAG
            @1,0 say "HTSCROLLTHUMBDRAG"

         ENDIF

            o:Update( nInc, 100, .t.  )
            DispOutAt(10,20,nInc)

       ENDIF

     ENDDO

RETURN

#endif


//

CLASS ScrollBar

      DATA nTRow, nTCol, nBRow, nBCol
      DATA cColor    AS "W/N"
      DATA nPos      AS 1
      DATA nTotal    AS 0
      DATA nWidth    AS 1
      DATA cFill     AS ""
      Data cUpArrow  AS ""
      Data cDnArrow  AS ""
      DATA cThumb    AS ""

      METHOD New( nTR, nTC, nBR, cClr, nPos )
      METHOD Display()
      METHOD Update( nCurrent, nTotal, lForceUpdate )
      METHOD HitTest( nRow, nCol )

ENDCLASS


//
METHOD New( nTopRow, nTopColumn, nBottomRow, ;
                        cColorString, nInitPosition)
//

   ::nTRow   := nTopRow
   ::nTCol   := nTopColumn
   ::nBRow   := nBottomRow
   ::nBCol   := nTopColumn+Len(::cFill)-1
   ::cColor  := cColorString
   ::nPos    := IF( nInitPosition == NIL, 1, nInitPosition )

RETURN( self )
   


//
METHOD Display()
//
   LOCAL nRow

   ::nBCol   := ::nTCol+Len(::cFill)-1
   DispBegin()

   // Draw the arrows
   DispOutAt( ::nTRow, ::nTCol, ::cUpArrow, ::cColor  )
   DispOutAt( ::nBRow, ::nTCol, ::cDnArrow, ::cColor  )

   // Draw the background
   FOR nRow := ::nTRow + 1 TO ::nBRow - 1
      DispOutAt( nRow, ::nTCol, ::cFill, ::cColor  )
   NEXT

   DispOutAt( (::nPos + ::nTRow), ::nTCol, ::cFill, ::cColor  )

   DispEnd()

RETURN( self )
   


//
METHOD Update( nCurrent, nTotal, lForceUpdate )
//
   LOCAL nNewPosition
   LOCAL nScrollHeight := ( ::nBRow - ::nTRow ) -1
   LOCAL aSave         := { Row(), Col() }

   DEFAULT lForceUpdate := .T.

   ::nBCol   := ::nTCol+Len(::cFill)-1

   IF nTotal < 1
      nTotal := 1
   ENDIF

   IF nCurrent < 1
      nCurrent := 1
   ENDIF

   IF nCurrent > nTotal
      nCurrent := nTotal
   ENDIF

   // Determine the new position
   nNewPosition := ROUND( (nCurrent / nTotal) * nScrollHeight, 0 )

   // Resolve algorythm oversights
   nNewPosition := IF( nNewPosition < 1, 1, nNewPosition )
   nNewPosition := IF( nCurrent == 1, 1, nNewPosition )
   nNewPosition := IF( nCurrent >= nTotal, nScrollHeight, nNewPosition )

   // Overwrite the old position (if different), then draw in the new one
   IF nNewPosition <> ::nPos .OR. lForceUpdate
      DispBegin()
      DispOutAt( (::nPos+::nTRow), ::nTCol, ::cFill, ::cColor  )
      DispOutAt( (nNewPosition+::nTRow), ::nTCol, ::cThumb, ::cColor )
      ::nTotal := nTotal
      ::nPos   := nNewPosition
      DispEnd()
   ENDIF

   SetPos( aSave[1], aSave[2] )
RETURN( self )
   

//
METHOD HitTest( nRow, nCol )
//
Local nRet   := 0
DEFAULT nRow := MRow()
DEFAULT nCol := MCol()

::nBCol   := ::nTCol+Len(::cFill)-1

IF MInRect( ::nTRow, ::nTCol, ::nBRow, ::nBCol )

    IF     MRow() == ::nBRow .and. MCol() >= ::nBCol()   // v
            nRet := HTSCROLLUNITINC
    ELSEIF MRow() == ::nTRow .and. MCol() >= ::nTCol()   // ^
            nRet := HTSCROLLUNITDEC

    ELSEIF MRow() == ::nTRow+::nPos .and. MCol() >= ::nTCol // on the thumb
            nRet := HTSCROLLTHUMBDRAG
    ELSEIF MRow() > ::nTRow+::nPos                       // under thumb
            nRet := HTSCROLLBLOCKINC

    ELSEIF MRow() < ::nBRow-::nPos                       // above thumb
            nRet := HTSCROLLBLOCKDEC

    ENDIF

ENDIF

RETURN( nRet )

