/****
*
*      oBind.Prg
*      oObject Demonstration.
*
*      NOTE:
*      -----
*      Demonstrates direct manipulation of class IVars w/out the
*      :: operator.
*
*      This method speeds up the whole internal class processing but
*      should be used with caution.
*
*      Do NOT EVER modify any INLINE class variables. The code
*      block that they execute is their IVar value. If you modify
*      that, you will crash & burn the moment you call them.
*      (except if you want to replace their code block with a
*      different one allthough I doon't see why you'd want to do
*      that <g>)
*
*      note: #define NO_DIRECT_IVARS to use the ::nMessage() internal
*      method.
*/

#include "oObject.ch"

// -> These point directly to the object's internal array
#xTranslate @:test1 => self\[\1]
#xTranslate @:test2 => self\[\2]
#xTranslate @:test3 => self\[\3]

PROC TestBind()
Local o := Test():New()
cls
? "Before..."
? "-----------------------------------------------------------------"
? "o:Test1 -> ", o:Test1
? "o:Test2 -> ", o:Test2
? "o:Test3 -> ", o:Test3
?
? "Press a key to directly modify class variables..."
inkey(0)

o:Alter()              // here's the juice...

?
? "After..."
? "-----------------------------------------------------------------"
? "o:Test1 -> ", o:Test1
? "o:Test2 -> ", o:Test2
? "o:Test3 -> ", o:Test3

RETURN

/*---------------------------------------------------------------------------*/
CLASS Test ALIAS Tst

DATA test1               // If you change the order of the IVars you MUST
DATA test2               // also change the defines above
DATA test3
METHOD new() INLINE ::Test1 := "Test1", ;
                    ::Test2 := "Test2", ;
                    ::Test3 := "Test3"
METHOD Alter()
ENDCLASS


/*---------------------------------------------------------------------------*/
METHOD Alter()

     @:Test1 := "Test1 has been directly modified..."
     @:Test2 := "Test2 has been directly modified..."
     @:Test3 := "Test3 has been directly modified..."

RETURN self
