/****
*
*      oDBTest1.prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates use of INLINE ... NOSELF clauses
*      and inline .DBF fields assignment to class variables
*
*      Also note that the ::Recno() method behaves like an
*      ACCESS-ASSIGN method.
*
*/

#include "oObject.ch"

Proc Test3()
Local oDB
cls
oDB := DBF():New("addbk")
odb:AddFlds()                 // --> you can also call it in oDB:New()
oDB:Recno(5)                  // --> no chaining here !!! No self is returned
oDB:Read()
oDB:ClassInfo()
? "oDB:Name  ", oDB:Name()     // note: ()
? "oDB:Name()", oDB:Name
?
? "----------------------------------------------------"
? "First Record dump..."
? "----------------------------------------------------"
oDB:Qout()                   // dump the ::buffer
Inkey(0)

oDB:GoBottom():Read()
? "----------------------------------------------------"
? "Last Record dump..."
? "----------------------------------------------------"
oDB:Qout()                   // dump the ::buffer
inkey(0)

oDB:Name := "Altered Name..."
? "----------------------------------------------------"
? "Last Record - oDB:Name is altered"
? "If we call oDB:Write() the record also will be altered"
? "----------------------------------------------------"
oDB:Qout()                   // dump the ::buffer
inkey(0)

oDB:Axit()
RETURN

/*---------------------------------------------------------------------------*/
CLASS DBF ALIAS DB
/*---------------------------------------------------------------------------*/
DATA Buffer     AS {}         // Must be #1 as self[1]
DATA Alias      AS ""
DATA Struc      AS {}
DATA nFlds      INLINE (::alias)->(FCount())
DATA Recno(n)   INLINE IF( n == NIL, ;
                           (::alias)->(RECNO()), ;
                           (::alias)->(dbGoTo(n)) )  ;
                           NOSELF

DATA Eof()      INLINE (::alias)->(EOF()) NOSELF   // Returns .T. or .F.
DATA Bof()      INLINE (::alias)->(BOF()) NOSELF

DATA goTop()    INLINE (::alias)->(dbGoTop())
DATA goBottom() INLINE (::alias)->(dbGoBottom())

METHOD New      =   dbNew
METHOD AddFlds  =   dbAddFlds
METHOD Read     =   dbRead
METHOD Write    =   dbWrite
METHOD QOut     =   dbQOut
ENDCLASS


/*---------------------------------------------------------------------------*/
METHOD FUNCTION dbNew(cAlias)
/*---------------------------------------------------------------------------*/
USE (cAlias) NEW
::Alias := ALIAS()  //cAlias
::Struc := (::alias)->(dbStruct())
::buffer := array(  ( ::alias )->( fcount() )  )  //--> init ::buffer
::GoTop():Read()
Return(  self  )

/*---------------------------------------------------------------------------*/
METHOD FUNCTION dbRead()
/*---------------------------------------------------------------------------*/
   AEval( ::Buffer, {| u, n | ::Buffer[n] := FieldGet(n) } )
RETURN self

/*---------------------------------------------------------------------------*/
METHOD FUNCTION dbWrite()
/*---------------------------------------------------------------------------*/
   AEval( ::Buffer, {| u, n | FieldPut( n, u ) } )
RETURN self

/*---------------------------------------------------------------------------*/
METHOD FUNCTION dbQout()
/*---------------------------------------------------------------------------*/
   AEval( ::Buffer, {| e | QOut( e ) } )
RETURN self

// this method initialises INLINE IVars with fieldnames but gets
// the actual data from ::buffer so make a ::read() before any
// update and put values back with ::write()
/*---------------------------------------------------------------------------*/
METHOD FUNCTION dbAddFlds()
/*---------------------------------------------------------------------------*/
Local i
IF empty( ::buffer )
     ::Read()
endif

FOR i=1 TO (::alias)->(FCount())
// --> Note: self[1] is ALWAYS ::buffer
  ::InsData( Field( i ), &( "{ | Self, xVal | if( xVal == NIL, Self[1][" +;
      Str(i) + "], Self[1][" + Str(i) + "] := xVal ) }" ) )
    NEXT

Return(  self  )


