/****
*
*      oInheri2.Prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates inheritance of Clipper's native classes
*      Demo Class DBrowse() is a perfect copy of TBrowseDB but you can add
*      as many new IVars and Methods as you wish.
*
*      Also take a look at "oSubClas.Prg" for an alternate technique using
*      ths SUBCLASS command. Note that "oSubClas.Prg" is a little bit faster.
*/

#include "oObject.ch"
#include "Inkey.ch"

PROC Test()
Local i, nKey, o

USE ADDBK ALIAS DATA NEW
Scroll()

DispBegin()

     DispBox( 0,0,MaxRow(),MaxCol() )
     DispOutAt( 0,2,"[ Use up/down/left/right - ESCape exits ]", "n/w")
     i := seconds()
     o := DBrowse():New( 1, 1, maxrow()-1, MaxCol() -1 )
     i := seconds()-i
     o:HeadSep := ""
     o:ColSep  := "  "

DispEnd()
alert( "Seconds to create Class: "+str(i) )
o:ClassInfo()

FOR i=1 TO data->(FCount())
     o:AddColumn( TBColumnNew( data->(FieldName(i)), data->(FieldBlock(FieldName(i))) ) )
NEXT

o:Freeze  := 1
o:Display()

WHILE .T.
   DispBegin()
   o:ForceStable()
   DispEnd()

   nKey := Inkey(0)

   IF nKey == K_ESC
      EXIT
   ELSE
      o:ApplyKey( nKey )
   ENDIF

ENDDO

Scroll()

RETURN


//

CLASS DBrowse FROM TBrowseDB
METHOD New( t,l,b,r )
METHOD ApplyKey(nKey)
METHOD Display() INLINE DispBegin(),     ;
                        ::RefreshAll(),  ;
                        ::ForceStable(), ;
                        DispEnd()
ENDCLASS


METHOD New( t,l,b,r )
::nTop    := t
::nLeft   := l
::nBottom := b
::nRight  := r
RETURN self


METHOD ApplyKey(nKey)
DO CASE
   CASE nKey == K_UP    ; ::Up()
   CASE nKey == K_DOWN  ; ::Down()
   CASE nKey == K_LEFT  ; ::Left()
   CASE nKey == K_RIGHT ; ::Right()
ENDCASE
RETURN self
