/****
*
*      oInheri3.Prg
*      oObject Demonstration.
*
*      NOTE:
*      -----
*      Demonstrates multiple inheritance of native classes. The first class
*      inherits TBROWSE. The test function calls the fourth class and alters
*      ::colorspec that came from the first class. Then it calls forcestable()
*      to stabilize the browse.
*      
*      Class #4 has no IVars or methods of its own. It uses messages created
*      in Class #1.
*
*      Class #4 also makes use of Class #2. It uses Class #2 New() method and
*      after altering a few TBROWSE IVars redisplays the browse. Note that
*      since we point to the same TBROWSE object of Class #1, we don't need
*      To add columns again.
*/

#include "oobject.ch"

Proc test()
local i, o
USE "addbk.dbf" ALIAS data NEW
cls
o := TestDB4():New(10, 10, 20, 30)

o:ClassInfo()

FOR i=1 TO data->(FCount())
   o:AddColumn( TBColumnNew( data->(FieldName(i)), data->(FieldBlock(FieldName(i))) ) )
NEXT
o:freeze    := 1
o:Autolite  := .T.
o:ColorSpec := "n/w,w/n"
o:Forcestable()
inkey(0)

Scroll()
o:Cls2Super:New(2,1,20,79)            // alter coordinates
o:Cls2Super:freeze    := 2
o:Cls2Super:Autolite  := .T.
o:Cls2Super:ColorSpec := "n/w,w/n"
o:Cls2Super:HeadSep   := ""
o:Cls2Super:ColSep    := "  "
o:Cls2Super:Forcestable()            // redisplay class #2
Return


//

CLASS TestDB From TBrowseDB ALIAS Cls1
DATA Test1  AS "I'm Test1 IVar..."
DATA Test2  AS "I'm Test2 IVar..."
METHOD New(a,b,c,d) INLINE ::nTop := a, ;
                           ::nLeft := b, ;
                           ::nBottom := c,;
                           ::nRight := d
ENDCLASS

//

CLASS TestDB2 FROM TestDB ALIAS Cls2
METHOD New(a,b,c,d) INLINE  ::cls1New(a,b,c,d)
ENDCLASS

//

CLASS TestDB3 FROM TestDB2 ALIAS Cls3
METHOD New(a,b,c,d) INLINE  ::cls2New(a,b,c,d)
ENDCLASS

//

CLASS TestDB4 FROM TestDB3 ALIAS Cls4
METHOD New(a,b,c,d) INLINE  ::cls3New(a,b,c,d)
ENDCLASS
