/****
*
*      oInherit.Prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates Multiple inheritance and user defined GET SET IVars
*      Take a look at ::TestUser IVar in the last class. The GET-SET Function
*      Not only updates the variable but also performs an ALERT().
*      ::TestUser also demonstrates direct modification of self...
*/

#include "oObject.ch"

Proc TestInherit()

Local o := GrandChild():New()

o:ClassInfo()

// --- call them from within child class ---

o:oFMessage()
o:oCMessage()
o:Message()

// --- call them directly ---

? "o:super(FATHER):Test1 -> ", o:super(FATHER):Test1
? "o:super(FATHER):Test2 -> ", o:super(FATHER):Test2
? "o:super(FATHER):Test3 -> ", o:super(FATHER):Test3
  o:Super(FATHER):Message()
  o:Super(CHILD):Message()

? "o:TestUser before ->", o:TestUser
o:TestUser := "Hello, New value here..."
? "o:TestUser after  ->", o:TestUser
o:Message2()

o:TestSuper()

o:Axit()

Return


/*---------------------------------------------------------------------------*/
CLASS Father ALIAS oF
/*---------------------------------------------------------------------------*/
// Initialise values of father IVars here because
// we will never use father:New()
DATA test1   AS "Father Data #1"
DATA test2   AS "Father Data #2"
DATA test3   AS "Father Data #3"
DATA test4   AS "Father Data #4"

DATA Message INLINE Alert( "This is Father:Message;"+::Test3,,"w+/b" )
METHOD New   INLINE ::Test1 := "Father Data #1", ;
                    ::Test2 := "Father Data #2", ;
                    ::Test3 := "Father Data #3"
ENDCLASS


/*---------------------------------------------------------------------------*/
CLASS Child FROM Father ALIAS oC
/*---------------------------------------------------------------------------*/
// Initialise values of child IVars here because
// we will never use child:New()
DATA test1   AS "Child Data #1"
DATA test2   AS "Child Data #2"
DATA test3   AS "Child Data #3"
DATA test4   AS "Child Data #4"
DATA test5   AS "Child Data #5"
DATA test6   AS "Child Data #6"

DATA Message INLINE Alert( "This is Child:Message",, "w+/g" )
DATA Message2 INLINE Alert( ::test4,, "w+/g" )

METHOD New   INLINE ::Test1 := "Child Data #1", ;
                    ::Test2 := "Child Data #2", ;
                    ::Test3 := "Child Data #3"
ENDCLASS




/*---------------------------------------------------------------------------*/
CLASS GrandChild FROM Child ALIAS oG
/*---------------------------------------------------------------------------*/

// uncomment to use ::nMessage()
// #define NO_DIRECT_IVARS

#xTranslate @:TestUser  => self\[\1]

DATA TestUser AS "-TestUser initial Data...-" GETSET __TstUser

DATA test1  AS "GrandChild Data #1"
DATA test2  AS "GrandChild Data #2"
DATA test3  AS "GrandChild Data #3"
DATA test4  as "::super Method using ::child IVars..."
DATA test5  as "::test5 -> GrandChild:test5 overrides child:test5"

DATA Message INLINE Alert( "This is GrandChild:Message",,"w+/rb" )
METHOD New   INLINE ::Test1 := "Grand-Child Data #1", ;
                    ::Test2 := "Grand-Child Data #2", ;
                    ::Test3 := "Grand-Child Data #3"
Method TestSuper = GChTestSuper
ENDCLASS


METHOD Function GChTestSuper()
alert( ::test5,,"w+/rb" )
alert( ::test6,,"w+/rb" )
alert( ::super:test4,,"w+/g" )
::oFMessage()
return( self )

/****
*
*     GET-SET Function for IVAR ::TestUser
*     Class GrandChild
*
*/

/*---------------------------------------------------------------------------*/
Function __TstUser(xVal)
/*---------------------------------------------------------------------------*/
Local self := QSelf()
Local cTemp := @:TestUser  //hold old value
IF xVal == NIL
   Return @:TestUser
else
   @:TestUser:= xVal
Endif
alert("Called from within ::TestUser;"+;
      "-----------------------------;"+;
      "New Value:                   ;"+;
      @:TestUser +";;"+;
      "Old Value:                   ;"+cTemp ;
     ,,"gr+/b")
RETURN @:TestUser

