#include "Common.ch"
#include "ClipOO.Ch"

/****
*
*     CLASS SAY
*
*     Created with ClipOO.CH
*
*/

#define NTOP    QSelf()[1]
#define NLEFT   QSelf()[2]
#define CTEXT   QSelf()[3]
#define CCOLOR  QSelf()[4]
#define CSAVE   QSelf()[5]
#define NLEN    QSelf()[6]

#xTranslate  o.nTop   => QSelf()\[\1]
#xTranslate  o.nLeft  => QSelf()\[\2]
#xTranslate  o.cText  => QSelf()\[\3]
#xTranslate  o.cColor => QSelf()\[\4]
#xTranslate  o.cSave  => QSelf()\[\5]
#xTranslate  o.nLen   => QSelf()\[\6]

// Class Example...
//-------------------------------------------------------------------//
Proc oSayTest()
//-------------------------------------------------------------------//
Local o1, o2
Local nH, aClass, i, xVal
Scroll()
o1 := SayNew():New( 2,2,"~Hello ~There ~1"):Display()
o2 := SayNew():New( 12,20,"~Hello ~There ~2"):Display()
Inkey(0)
o1:Hide()
o2:Hide()
Return

// --->  Class SAY  <---
//-------------------------------------------------------------------//
CLASS SayNew NAME Say  FROM TBrowseDB
//-------------------------------------------------------------------//

//-------------------------------------------------------------------//
CLASS DATA:
//-------------------------------------------------------------------//
     DATA nTop,  __nTop
     DATA nLeft, __nLeft
     DATA Text,  __Text
     DATA Color, __Color
     DATA cSave, __cSave
     DATA nLen, __nLen
END DATA

//-------------------------------------------------------------------//
CLASS METHODS:
//-------------------------------------------------------------------//
     METHOD New,     __SayNew
     METHOD Display, __SayDisplay
     METHOD Hide,    __SayHide
END METHODS
END CLASS


//-------------------------------------------------------------------//
METHOD __SayNew(nT, nL, txt, Clr) CLASS Say
//-------------------------------------------------------------------//
DEFAULT nL TO 0
DEFAULT nT TO 0
DEFAULT Clr TO "W/N, W+/N"
DEFAULT txt TO ""
o.cSave := ""
o.nTop  := nT
o.nLeft := nL
o.cText := Txt
o.cColor:= Clr
o.nLen  := HotstrLen( o.cText )
o.cSave := SaveScreen( o.nTop, o.nLeft, o.nTop, o.nLeft+o.nLen )
Return( self )

//-------------------------------------------------------------------//
METHOD __SayDisplay() CLASS Say
//-------------------------------------------------------------------//
::Hide()
o.cSave := SaveScreen( o.nTop, o.nLeft, o.nTop, o.nLeft+o.nLen )
SayHot( o.nTop, o.nLeft, o.cText, o.cColor )
Return( self )

//-------------------------------------------------------------------//
METHOD __SayHide() CLASS Say
//-------------------------------------------------------------------//
restscreen( ::nTop, ::nLeft, ::nTop, ::nLeft+::nLen, ::cSave )
::cSave := ""
Return( self )


// This is how simple it is
//-------------------------------------------------------------------//
DATA METHOD __nTop    OF o.nTop    GETSET
DATA METHOD __nLeft   OF o.nLeft   GETSET
DATA METHOD __Text    OF o.cText   GETSET
DEFINE DATA __cSave   OF o.cSave   GETSET
//-------------------------------------------------------------------//

//-------------------------------------------------------------------//
Function  __Color(Clr)
//-------------------------------------------------------------------//
RETURN( IF( Clr == NIL, o.cColor, o.cColor := Clr ) )

//-------------------------------------------------------------------//
Function  __nLen( nLen )
//-------------------------------------------------------------------//
RETURN( HotStrLen( o.cText ) )



//------------------------- UTILITY FUNCTIONS -----------------------//


//----------------------------------------------------//
STATIC FUNCTION SayHot( nRow, nCol, cStr, cColor )
//----------------------------------------------------//
Local i          := 0
Local cColorHot  := ""
Local cColorNorm := ""
Local cCopy      := ""
DEFAULT nRow     TO Row()
DEFAULT nCol     TO Col()
DEFAULT cColor   TO SetColor()

cColorNorm := substr(cColor, 1, at(",", cColor) - 1 )
cColorHot  := substr(cColor, at(",", cColor) + 1 )

dispbegin()
For i = 1 to len( cStr )
     IF substr( cStr, i, 1 ) == "~" .OR. substr( cStr, i, 1 ) == "&"
        DispOutAt( nRow,nCol,SubStr( cStr, i+1,1), cColorHot )
        cCopy += SubStr( cStr, i+1,1)
        i++
     Else
        DispOutAt( nRow, nCol, SubStr( cStr, i,1), cColorNorm )
        cCopy += SubStr( cStr, i,1)
     Endif
     nCol++
Next
dispend()
return( Len(cCopy) )



/*---------------------------------------------------------------------------*/
STATIC Function HotStrLen( cStr )
/*---------------------------------------------------------------------------*/
Local cCopy := ""
Local i
For i = 1 to len( cStr )
     if substr( cStr, i, 1 ) != "~" .and. substr(cStr,i,1) != "&"
          cCopy += substr(cStr,i,1)
     Endif
Next
Return( Len( cCopy ) )
