/****
*
*      oSubClas.Prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates use of the SUBCLASS statement. There is no need to
*      "subclass" all IVars and Methods of the target object. Some IVars
*      can be internally manipulated by our class.
*
*      In this class I use the SUBCLASS command only to the absolutely
*      necassary Methods and IVars.
*
*      SubClassing is useful in creating small and fast classes without much
*      overhead.
*
*
*/

#include "oObject.ch"
#include "inkey.ch"

PROC Test()
Local i, nKey, oB
USE ADDBK NEW ALIAS data
scroll()

oB := TBTest():New( 1,1,MaxRow()-1,MaxCol()-1 )
oB:ColorSpec:= "n/w, w/n"
DispBox( 0,0,MaxRow(),MaxCol(),,oB:ColorSpec )
DispOutAt( 0,2,"[ Use up/down/left/right - ESCape exits ]", oB:ColorSpec)
FOR i=1 TO data->(FCount())
   oB:AddColumn( TBColumnNew( data->(FieldName(i)), data->(FieldBlock(FieldName(i))) ) )
NEXT

oB:RefreshAll():ForceStable()
oB:Freeze:= 1
WHILE .T.
   oB:ForceStable()
   nKey := Inkey(0)
   IF nKey == K_ESC
      EXIT
   ELSE
      oB:ApplyKey( nKey )
   ENDIF
ENDDO

Scroll()

RETURN

//

CLASS TBTest ALIAS oTB

DATA oTB              AS TBrowseDB()

DATA   Freeze          SUBCLASS oTB
DATA   ColorSpec       SUBCLASS oTB
METHOD ForceStable()   SUBCLASS oTB
METHOD RefreshAll()    SUBCLASS oTB
MESSAGE AddColumn( o ) IS AddColumn IN oTB  // classy syntax
METHOD New( nTop, nLeft, nBottom, nRight )
METHOD ApplyKey(nKey)
ENDCLASS


METHOD New( nTop, nLeft, nBottom, nRight )
::oTB:nTop    := nTop
::oTB:nLeft   :=nLeft
::oTB:nBottom :=nBottom
::oTB:nRight  :=nRight
::oTB:HeadSep := ""
::oTB:ColSep  := "  "

Return( Self )

METHOD ApplyKey(nKey)
DO CASE
   CASE nKey == K_UP    ; ::oTB:Up()
   CASE nKey == K_DOWN  ; ::oTB:Down()
   CASE nKey == K_LEFT  ; ::oTB:Left()
   CASE nKey == K_RIGHT ; ::oTB:Right()
ENDCASE
RETURN self
