/****
*
*      TestSta2.Prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates use of STATIC Methods. Inherits from class BOX in
*      TestStat.prg
*/

#include "oObject.ch"

// test the WINDOW class
PROC MoveWin()
Local o
scroll()
DispOutAt( 1,2, "Press any key to move Window", "w+/n")
o := Window():New( 10,10,20,30)
o:ClassInfo()
o:cColor := "n/w"
o:Display()
inkey(0)
o:Hide():Move( -3, -3 ):Display()
inkey(0)
o:Hide():Move( -3, -3 ):Display()
inkey(0)
o:Hide():Move( 0, 5 ):Display()
inkey(0)
o:Hide():Move( 0, 5 ):Display()
inkey(0)
o:Hide():Move( 5, 5 ):Display()
inkey(0)
o:Hide():Move( 3, 5 ):Display()

RETURN


//
CLASS Window FROM Box ALIAS Win
DATA nTop, nLeft
METHOD New(a,b,c,d,e,f)     // STATIC Constructor Method
METHOD Move( nRows, nCols )

ENDCLASS


//
// Constructor Method UDF. It uses ::super:<message> to access parent
// Methods. However, to use ::super:New() you must initialize the local
// IVars.
// To avoid this use the aliased method ::BoxNew() and the local IVars
// will be initialized automatically.
// Note: ::BoxNew() is faster
//
//
METHOD New(a,b,c,d,e,f) //CLASS Window

// Three ways to access ::super
//-> (1) Call ALIASed super Method (Faster)
//-> ::BoxNew(a,b,c,d,e,f)

::nTop    := a
::nLeft   := b
::nBottom := c
::nRight  := d
::cBox    := Replicate( "+", 8)+" "   // change the frame of ::super
::cColor  := f

//-> (2) Call ::dict:Super:NEW( <params> ) - Same as bellow
//-> ::dict:Super:NEW( a,b,c,d,e,f )

//-> (3) Call ::Super:New( <Params> ) - Fast enough but <Params> must be
//-> initialised as shown above (::nTop, :nLeft etc.) to be used by ::Super
//-> ::Super:NEW( a, b, c, d, e, f )
//-> ::BoxSuper:NEW( a, b, c, d, e, f )

::Super:NEW( ::nTop, ::nLeft, ::nBottom, ::nRight, ::cBox, ::cColor )

Return self


//

METHOD Move( nRows, nCols )
DEFAULT nRows := 0, nCols := 0
::nTop   += nRows
::nLeft  += nCols
::nBottom+= nRows
::nRight += nCols
RETURN self

