/****
*      OOBJECT.PRG version 2.B
*
*      Part of oObject.lib
*      (c) 1997-1998 Manos Aspradakis
*
*/

#include "_OBJECT_.CH"

REQUEST __BSG001, __BSG051, __BSG101, __BSG151, __BSG201, __LSG001

#define LEN_OBJECT_CLASS     11
#define MAX_CLASS_IVARS     250
#define MAX_CLASS_METHODS   250

STATIC saClasses := {}     // holds class init blocks


// _OBJECT_ Class Definition. This is how to create a stand alone class
// using Clipper's internal facilities...
//
FUNCTION OBJECT()
//
Static nClassH := 0
Local oNew
if nClassH == 0
   __Rq1()          // -> request ASM externals

     nClassH := __ClassNew( "_OBJECT_", LEN_OBJECT_CLASS )

     // IVars
     __ClassAdd( nClassH, "Name"      ,"__IVGET001" )
     __ClassAdd( nClassH, "_Name"     ,"__IVSET001" )
     __ClassAdd( nClassH, "IVars"     ,"__IVGET002" )
     __ClassAdd( nClassH, "_IVars"    ,"__IVSET002" )
     __ClassAdd( nClassH, "Methods"   ,"__IVGET003" )
     __ClassAdd( nClassH, "_Methods"  ,"__IVSET003" )
     __ClassAdd( nClassH, "Handle"    ,"__IVGET004" )
     __ClassAdd( nClassH, "_Handle"   ,"__IVSET004" )
     __ClassAdd( nClassH, "NewObj"    ,"__IVGET005" )
     __ClassAdd( nClassH, "_NewObj"   ,"__IVSET005" )
     __ClassAdd( nClassH, "Super"     ,"__IVGET006" )
     __ClassAdd( nClassH, "_Super"    ,"__IVSET006" )
     __ClassAdd( nClassH, "Scope"     ,"__IVGET007" )
     __ClassAdd( nClassH, "_Scope"    ,"__IVSET007" )
     __ClassAdd( nClassH, "ClsAlias"  ,"__IVGET008" )
     __ClassAdd( nClassH, "_ClsAlias" ,"__IVSET008" )
     __ClassAdd( nClassH, "bSuper"    ,"__IVGET009" )
     __ClassAdd( nClassH, "_bSuper"   ,"__IVSET009" )
     __ClassAdd( nClassH, "nElem"     ,"__IVGET010" )
     __ClassAdd( nClassH, "_nElem"    ,"__IVSET010" )
     __ClassAdd( nClassH, "nMElem"    ,"__IVGET011" )
     __ClassAdd( nClassH, "_nMElem"   ,"__IVSET011" )

     // Methods

     __ClassAdd( nClassH, "New"         , "__oNew"         )
     __ClassAdd( nClassH, "AddIVar"     , "__oAddIVar"     )
     __ClassAdd( nClassH, "AddData"     , "__oAddData"     )
     __ClassAdd( nClassH, "DelData"     , "__oDelData"     )
     __ClassAdd( nClassH, "AddMethod"   , "__oAddMethod"   )
     __ClassAdd( nClassH, "DelMethod"   , "__oDelMethod"   )
     __ClassAdd( nClassH, "ClassHandle" , "__oClassHandle" )
     __ClassAdd( nClassH, "Insert"      , "__oClsIns"      )
     __ClassAdd( nClassH, "EndInsert"   , "__oClsEndIns"   )

ENDIF

oNew :=__ClassIns( nClassH ) ;;
RETURN( IF( !Valtype(oNew)=="O", ;
           Alert("ERROR!!!;OBJECT: NOT Inserted !!!"), ;
           oNew ) )


// ->
// -> _OBJECT_ Class constructor method
// ->
/*---------------------------------------------------------------------------*/
METHOD __oNew( cName, bSuper, cAlias )
/*---------------------------------------------------------------------------*/
//STATIC IsFirstime := .T.
Local i
Local oTest
Local cClName, aSupIVars
Local nH, aCls
Local aMeths, aIvars

/* Default ::ClsAlias To ClassName */
/* Get the first 4 chars if cAlias is NIL */

IF  cAlias == NIL .OR. Empty(cAlias)
    cAlias :=  alltrim(LEFT( cName, 4 ))
ENDIF

/* Draw in requested Method Functions          */
/* Only the first time a class is initiated    */
/* See RQ*.PRG                                 */
//IF IsFirstime == .T.
//   IsFirstime := .F.
//   __Rq1()
//ENDIF

O_NAME         := UPPER(ALLTRIM(cName))
O_IVARS        := ARRAY( MAX_CLASS_IVARS, 7 )
O_METHODS      := ARRAY( MAX_CLASS_METHODS, 4 )
O_HANDLE       := 0
O_SUPER        := NIL
O_ALIAS        := cAlias
O_SCOPE        := SCOPE_EXPORT
O_NELEM        := 1
O_NMELEM       := 1

IF( bSuper != NIL, oTest := bSuper:Eval(),)   // --> Insert ::Super
    IF oTest != NIL
    O_BSUPER := bSuper
    nH   := oTest:ClassH()
    aCls := __CLASSSEL( nH )
        IF ASCAN( aCls, {|e| e = "DICT" }) > 0
             O_SUPER        :=  oTest  //ACLONE( oTest )
             aIVars         :=  ACLONE( oTest:Dict:IVars )
             aMeths         :=  ACLONE( oTest:Dict:Methods )

             // -> Exclude parent INTERNAL and LOCAL IVars
             FOR i = 1 to len( aIVars )

                   // --> Exclude parent internal IVars
                   IF      aIVars[i, IV_NAME]  == "DICT"
                   ELSEIF  aIVars[i, IV_NAME]  == "SUPER"
                   ELSEIF  aIVars[i, IV_SCOPE] == SCOPE_LOCAL
                   ELSE
                       O_IVARS[O_NELEM] :=  aIVars[i]
                       O_NELEM++
                   ENDIF
             NEXT

             FOR i = 1 to len( aMeths )

                  // --> Exclude parent internal & CLASS methods
                   IF      aMeths[i, M_SCOPE] == SCOPE_LOCAL
                   ELSEIF  aMeths[i, M_NAME]  == "__SUPER"
                   ELSEIF  aMeths[i, M_NAME]  == "__VIRTUAL"
                   ELSEIF  aMeths[i, M_NAME]  == "CLASSINFO"
                   ELSEIF  aMeths[i, M_NAME]  == "NMESSAGE"
                   ELSEIF  aMeths[i, M_NAME]  == "INSDATA"
                   ELSE
                       O_METHODS[O_NMELEM] :=  aMeths[i]
                       O_NMELEM++
                   ENDIF
             NEXT


        ELSE
             // -> Not an "oObject" object. Just draw it in...
             // -> This draws in Internal classes or any foreign classes
             // -> that use Clipper's class system
                O_SUPER   := oTest
                cClName   := O_SUPER:ClassName()

                // -> returns sorted array of Methods
                aSupIVars := aOMethods( O_SUPER )

                // -> First do super METHODS
                FOR i = 1 TO LEN( aSupIVars )

                //---------------------------------------------------//
                //  Alternate Routine - see __bSupMethods() below... //
                //---------------------------------------------------//
                // O_IVARS[O_NELEM] := { ;
                //                      aSupIVars[i], ;
                //                      __BSupMethods( aSupIvars[i] ),,;
                //                      0,,,alltrim(left(cClName,4))  ;
                //                      }
                //         O_NELEM++
                //---------------------------------------------------//

                IF aSupIVars[i] == "CLASSNAME" .OR. aSupIVars[i] == "CLASSH"
                ELSE
                O_METHODS[O_NMELEM] := { ;
                                         aSupIVars[i], ;
                                         "__SUPERMETHOD",;
                                         AllTrim(LEFT( cClName, 4 )),;
                                         0;
                                     }
                       O_NMELEM++
                ENDIF
                NEXT

                // -> returns sorted array of IVars
                aSupIVars := aOData( O_SUPER )

                // -> Second do super IVARS
                FOR i = 1 TO LEN( aSupIVars )
                O_IVARS[O_NELEM] := { ;
                                   aSupIVars[i], ;
                                   __BSupIVars( aSupIvars[i] ),,;
                                   0,,,;
                                   AllTrim(LEFT( cClName, 4 ))  ;  // Alias
                                   }
                       O_NELEM++

                NEXT

        ENDIF

    ELSE
    ENDIF   // Valtype(oTest)=="O"
    
RETURN Self



// ->
// -> RETURN the New object's handle
// -> o:Dict:Handle
// ->
/*---------------------------------------------------------------------------*/
METHOD __oClsHandle()
/*---------------------------------------------------------------------------*/
Return( O_HANDLE )




// ->
// ->  Add Simple IVars
// ->  Faster than the next two menthods...
// ->
/*---------------------------------------------------------------------------*/
METHOD __oADDIVar( cName, xFuncName, xValue, nScope, cLinkMethod, nDPos, cAlias )
/*---------------------------------------------------------------------------*/
Local nPos      := 0
DEFAULT nScope  := 0

cName := Upper( cName )

// -> Search for same IVar in parent class IVARS
IF (nPos := ASCAN( O_IVARS, ;
    { |e| e[IV_NAME] != NIL .and. UPPER( e[IV_NAME] ) == cName } ) ) > 0

ELSE
      O_IVARS[O_NELEM] :=  { cName, xFuncName, xValue, nScope, ;
                             cLinkMethod, nDPos, cAlias }
         O_NELEM++
ENDIF

RETURN Self


//
// Add a new Instance variable
// Each variable carries its alias as the 7th element
//
// I added some functionality (a second elseif) to service the case of
// mixed PUBLIC and STATIC methods/IVars of the same name in ::super and child
// classes
// There are four cases:
// a. Parent method is INLINE (IVar), child Method is METHOD
// b. Parent method is METHOD, child Method is INLINE (IVar)
// c. Parent method is METHOD, child Method is METHOD
// c. Parent method is INLINE (IVar), child Method is INLINE (IVar)
//
// Anyway, I scan both arrays to make sure and I ALIAS everything.
//
/*---------------------------------------------------------------------------*/
METHOD __oADDData( cName, xFuncName, xValue, nScope, cLinkMethod, nDPos, cAlias )
/*---------------------------------------------------------------------------*/
Local nPos      := 0
DEFAULT nScope  := 0

cName := Upper( cName )

// -> Search for same IVar in parent class IVARS
IF (nPos := ASCAN( O_IVARS, ;
    { |e| e[IV_NAME] == cName }, 1, O_NELEM-1 ) ) > 0

     // -> If Name is the same but parent IVar
     // -> is INLINE block method...
     IF valtype(O_IVARS[nPos, IV_FUNC]) == "B"

         // -> Rename parent IVar Name using parent ALIAS
         O_IVARS[nPos, IV_NAME] := O_IVARS[nPos,IV_ALIAS]+cName
         // -> and add the new IVar of THIS class
         O_IVARS[O_NELEM] := { cName, xFuncName, xValue, nScope, ;
                              cLinkMethod, nDPos, cAlias }
         O_NELEM++

     ELSE

         O_IVARS[nPos,IV_FUNC] := xFuncName // -> override parent IVar
         O_IVARS[nPos,IV_DATA] := xValue    // -> override parent IVar value

     ENDIF

// -> Search for same IVar Method in parent class METHODS
ELSEIF (nPos := ASCAN( O_METHODS, ;
       { |e| e[M_NAME] == cName }, 1, O_NMELEM-1 ) ) > 0

     // -> If Name is the same but child IVar
     // -> is INLINE block method...
     IF valtype(xFuncName) == "B"

         // -> Rename parent METHOD Name using parent ALIAS
         O_METHODS[nPos, M_NAME] := O_METHODS[nPos,M_ALIAS]+cName
         // -> and add the new INLINE IVar of THIS class
         O_IVARS[O_NELEM] := { cName, xFuncName, xValue, nScope, ;
                               cLinkMethod, nDPos, cAlias }
         O_NELEM++

     ELSE

         O_IVARS[nPos,IV_FUNC] := xFuncName // -> override parent IVar
         O_IVARS[nPos,IV_DATA] := xValue    // -> override parent IVar value

     ENDIF
ELSE
      O_IVARS[O_NELEM] :=  { cName, xFuncName, xValue, nScope, ;
                             cLinkMethod, nDPos, cAlias }
         O_NELEM++
ENDIF

RETURN Self



// ->
// -> Add a new Method
// -> Same comments as above...
// ->
/*---------------------------------------------------------------------------*/
METHOD __oADDMethod( cName, xFuncName, cAlias, nScope )
/*---------------------------------------------------------------------------*/
Local nPos     := 0
cName          := UPPER( cName )
DEFAULT nScope := 0
DEFAULT cAlias := UPPER( O_ALIAS )

// Search for same method name in Parent class
// if found, override it by aliasing the parent method
// using the O_METHODS array 3rd element ( alias )
// If parent class is already aliased the method name
// already has a different name and is not aliased here.

IF (nPos := ASCAN( O_METHODS, ;
            {|e| e[ M_NAME ] == cName }, 1, O_NMELEM-1 )) > 0

     // --> override parent method using parent method's alias
     O_METHODS[ nPos, M_NAME ] := O_METHODS[nPos, M_ALIAS] + cName

     // --> insert this class's method
     O_METHODS[O_NMELEM] :=  { cName, ;
                              UPPER(xFuncName), ;
                              cAlias, ;     //UPPER(O_ALIAS), ;
                              nScope }
         O_NMELEM++

ELSEIF (nPos := ASCAN( O_IVARS, ;
            {|e| e[ IV_NAME ] == cName }, 1, O_NELEM-1 )) > 0

     IF Valtype( O_IVARS[nPos, IV_FUNC] ) == "B"

     // --> override parent IVar method using parent IVar's alias
     O_IVARS[nPos, IV_NAME] := O_IVARS[nPos,IV_ALIAS]+cName

     ENDIF

     // --> insert this class's method
     O_METHODS[O_NMELEM] := { cName,  ;
                              UPPER(xFuncName), ;
                              cAlias, ;  //UPPER(O_ALIAS), ;
                              nScope }
         O_NMELEM++
ELSE
     // --> just insert this class's method
     O_METHODS[O_NMELEM] :=  { cName, ;
                              UPPER(xFuncName), ;
                              cAlias, ;  //UPPER(O_ALIAS), ;
                              nScope }
         O_NMELEM++


ENDIF

RETURN Self


// ->
// -> Remove a method (use with caution)
// ->
/*---------------------------------------------------------------------------*/
METHOD __oDELMethod( cName )
/*---------------------------------------------------------------------------*/
Local i, nSize
cName := UPPER(alltrim(cName))

FOR i=1 TO LEN(O_METHODS)

     if UPPER(alltrim(O_METHODS[ i, M_NAME ])) == UPPER(alltrim(cName))

          nSize := LEN( O_METHODS )
          ADEL( O_METHODS[i] )
          ASIZE( O_METHODS, nSize -1 )

     ENDIF

NEXT

RETURN Self



// ->
// -> Remove an instance variable
// ->
/*---------------------------------------------------------------------------*/
METHOD __oDELData( cName )
/*---------------------------------------------------------------------------*/
Local i, nSize
cName := UPPER(alltrim(cName))

FOR i=1 TO LEN(O_IVARS)

     if UPPER(alltrim(O_IVARS[ i, IV_NAME ])) == UPPER(alltrim(cName))

          nSize := LEN( O_IVARS )
          ADEL( O_IVARS[i] )
          ASIZE( O_IVARS, nSize -1 )

     ENDIF

NEXT

RETURN Self



// ->
// -> Create the new class
// ->
/*---------------------------------------------------------------------------*/
METHOD __oClsIns( hClass )
/*---------------------------------------------------------------------------*/
Local i, cCnt, oNew

  // --> add internal Methods and IVars
  O_IVARS[O_NELEM]    := {"DICT",, Self,0,,,}
  O_NELEM++
  O_METHODS[O_NMELEM] := {"__VIRTUAL" , "__VIRTUAL"    ,,0}
  O_NMELEM++
  O_METHODS[O_NMELEM] := {"CLASSINFO" , "__oClsInfo"   ,,0}
  O_NMELEM++
  O_METHODS[O_NMELEM] := {"INSDATA"   , "__oClsInsData",,0}
  O_NMELEM++
  O_METHODS[O_NMELEM] := { "NMESSAGE" , "__nClsMsg"    ,,0}
  O_NMELEM++

  // --> add ::super access IVars
  IF O_SUPER != NIL
     O_METHODS[O_NMELEM] := {"__SUPER", "__SUPER",,0}
     O_NMELEM++
     O_IVARS[O_NELEM]    := {"SUPER"        ,,O_SUPER,0,,,}
     O_NELEM++
     O_IVARS[O_NELEM]    := {O_ALIAS+"SUPER",,O_SUPER,0,,,}
     O_NELEM++
  ENDIF

  // --> Clip arrays so we don't have NIL elements
  ASIZE( O_IVARS, O_NELEM-1 )
  ASIZE( O_METHODS, O_NMELEM-1 )

  // --> get the handle for the new class
  O_HANDLE := __CLASSNEW( O_NAME, LEN( O_IVARS )+250 ) //(???)

  // --> add Methods directly...
  FOR i=1 TO LEN( O_METHODS )
        __ClassAdd( O_HANDLE, O_METHODS[i,M_NAME], ;
                              O_METHODS[i,M_FUNC]  )
  NEXT

  // --> IVars need more work...
  FOR i=1 TO LEN( O_IVARS )
    //IF O_IVARS[i,1] != NIL
        cCnt := PADL(LTRIM(STR(i)),3,"0")

         DO CASE

           // --> Scope READ ONLY. No linked IVars here
           CASE O_IVARS[i, IV_ATTRIB] == SCOPE_READONLY
              __ClassAdd( O_HANDLE,       O_IVARS[i,IV_NAME], "__IVGET"+ cCnt )
              __ClassAdd( O_HANDLE, "_" + O_IVARS[i,IV_NAME], "__IVGET"+ cCnt )

           // --> INLINE-BLOCK Ivars
           CASE Valtype( O_IVARS[i,IV_FUNC] ) == "B"
            __ClassAdd( O_HANDLE,       O_IVARS[i,IV_NAME], "__BSG"+ cCnt )
            __ClassAdd( O_HANDLE, "_" + O_IVARS[i,IV_NAME], "__BSG"+ cCnt )

           // --> Ivars with user defined GETSET Func
           CASE Valtype( O_IVARS[i,IV_FUNC] ) == "C"
             __ClassAdd( O_HANDLE,       O_IVARS[i,IV_NAME], O_IVARS[i,IV_FUNC])
             __ClassAdd( O_HANDLE, "_" + O_IVARS[i,IV_NAME], O_IVARS[i,IV_FUNC])

           // --> LINKed Ivars
           CASE valtype( O_IVARS[i, IV_LINKMETH])== "C"
               __ClassAdd( O_HANDLE,       O_IVARS[i,IV_NAME], "__LSG"+ cCnt )
               __ClassAdd( O_HANDLE, "_" + O_IVARS[i,IV_NAME], "__LSG"+ cCnt )

           OTHERWISE

           // --> Normal Ivars
           __ClassAdd( O_HANDLE,       O_IVARS[i,IV_NAME], "__IVGET"+ cCnt )
           __ClassAdd( O_HANDLE, "_" + O_IVARS[i,IV_NAME], "__IVSET"+ cCnt )

        ENDCASE
   // ENDIF
  NEXT

Return( O_HANDLE )



// ->
// -> Assign Values to inserted IVars...
// -> INLINE & STATIC Methods are assigned a Code Block
// ->
/*---------------------------------------------------------------------------*/
METHOD __oClsEndIns()
/*---------------------------------------------------------------------------*/
Local i
// -> ooEndIns( O_IVARS, O_NEWOBJ ) // C Function (works faster - gives errors)

FOR i=1 TO Len( O_IVARS )
      IF ValType( O_IVARS[i,IV_FUNC] ) == "B"
             O_NEWOBJ[i] := O_IVARS[i,IV_BLOCK]
      ELSE
             O_NEWOBJ[i] := O_IVARS[i,IV_DATA]
      ENDIF
NEXT

RETURN Self


/*---------------------------------------------------------------------------*/
/*                INTERNAL METHODS COMMON TO OBJECTS
/*---------------------------------------------------------------------------*/


// ->
// -> Force insert an entry into the Class table
// -> Only inserts INLINE block Methods...
// ->
/*---------------------------------------------------------------------------*/
METHOD __oClsInsData( cData, xFuncName, xData, nScope, cLinkMeth )
/*---------------------------------------------------------------------------*/
Local nH    := ::Dict:Handle  // --> ::ClassH()
Local nPos  := len( ::Dict:IVars ) + 1
Local nElem := 0
Local cCnt  := ""

DEFAULT nScope   := 0

nElem := ASCAN( ::Dict:IVars, {|e| e[1] == cData } )

     IF nElem == 0
           ::Dict:nElem+=1
           AADD(::Dict:IVars, { UPPER( cData ), xFuncName, xData, nScope,0, ::Dict:ClsAlias })

           cCnt := PADL( LTRIM( STR( nPos ) ), 3, "0" )

           DO CASE
                // -> Scope READ ONLY
                CASE nScope == SCOPE_READONLY
                   __ClassAdd( nH,       cData, "__IVGET"+ cCnt )
                   __ClassAdd( nH, "_" + cData, "__IVGET"+ cCnt )

                // Inline - Block
                CASE Valtype( xFuncName ) == "B"
                   __ClassAdd( nH,       cData, "__BSG"+ cCnt )
                   __ClassAdd( nH, "_" + cData, "__BSG"+ cCnt )

                // User defined GETSET Func
                CASE Valtype( xFuncName ) == "C"
                   __ClassAdd( nH,       cData, xFuncName )
                   __ClassAdd( nH, "_" + cData, xFuncName )

                // LINKed IVars
                CASE Valtype( cLinkMeth ) == "C"
                   __ClassAdd( nH,       cData, "__LSG"+ cCnt )
                   __ClassAdd( nH, "_" + cData, "__LSG"+ cCnt )

                OTHERWISE  // -> Scope NORMAL
                   __ClassAdd( nH,       cData, "__IVGET"+ cCnt )
                   __ClassAdd( nH, "_" + cData, "__IVSET"+ cCnt )

                ENDCASE

     IF ValType( xFuncName ) == "B"
          Self[nPos] := xFuncName               // assign ivar Block/Inline
     ELSE
          Self[nPos] := xData                   // assign ivar
     ENDIF

ENDIF

RETURN( self )


/****
*     METHOD nMessage( cMsg, xVal )
*     -----------------------------
*     Retrieves or sets the value of IVar <cMsg>.
*     Scans the self:dict:IVars array. If the IVar name matches the
*     self element of the IVar is directly manipulated. Otherwise
*     NIL is returned...
*/

/*---------------------------------------------------------------------------*/
METHOD __nClsMsg( cMsg, xVal )
/*---------------------------------------------------------------------------*/
Local i, nElem:=0
For i=1 TO Len( ::dict:IVars )
    IF ::dict:IVars[i,IV_NAME] = upper(cMsg)
          nElem := i
          EXIT
    ENDIF
NEXT
RETURN if( xVal == NIL, self[nElem], self[nElem] := xVal )


// -> internal VIRTUAL method for SubClassing
/*---------------------------------------------------------------------------*/
METHOD __VIRTUAL()
/*---------------------------------------------------------------------------*/
RETURN( self )


// -> Search up the Class tree for the right Class
// -> and RETURN the correct parent instance
// -> Resemples __PARENT() from oClip
/*---------------------------------------------------------------------------*/
METHOD __SUPER( cClass )
/*---------------------------------------------------------------------------*/
Local oChild := QSelf()
Local oParent := oChild:Super
IF valtype(oParent) == "O"
   IF cClass != NIL
       WHILE !( cClass  == oParent:Classname() )
             oParent    := oParent:Super
             IF oParent == NIL
                Exit
             ENDIF
       ENDDO
   ENDIF
ENDIF
RETURN( oParent )



// ->
// -> Class inspection table
// ->
/*---------------------------------------------------------------------------*/
METHOD __oClsInfo(nRow, nCol)
/*---------------------------------------------------------------------------*/
Local i, xType
Local oObj    := self:Dict
Local aClass  := {}
Local aSave   := { ROW(), COL(), SETCURSOR(0), SETCOLOR( "B/BG, W+/B" ), ;
                   SAVESCREEN(0,0,MAXROW(),MAXCOL()) }

AADD( aClass,  PADC("CLASS NAME: " + Self:ClassName()+ ' ( Alias: "'+self:dict:ClsAlias+'" )',70) )
AADD( aClass,  replicate("=",70)  )
AADD( aClass,  PADR("CLASS DATA ("+Alltrim(str(len(oObj:IVars)))+")",20," ") ;
               + "VALUE"  )
AADD( aClass,  replicate("-",70) )

FOR i=1 TO LEN( oObj:IVars )

     IF valtype( oObj:Ivars[ i, IV_FUNC ] ) == "B"
         AADD( aClass,  padr(oObj:IVars[i,1],20," ") + "{ || ... }"  )
     ELSEIF ( valtype( oObj:Ivars[ i, IV_FUNC ] ) != "B" )
        xType := ValType( Self[i] )
        IF xType == "O"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + '<object> => ("'+UPPER(self[i]:classname())+'")'  )
        ELSEIF xType == "A"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + '{ ... }'  )
        ELSEIF xType == NIL
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + "<NIL>"  )
        ELSEIF xType == "L"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + IF( self[i] == .T., ".T.", ".F.") )
        ELSEIF xType == "O"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + '<object> => ("' +UPPER(self[i]:classname())+'")'  )
        ELSEIF xType == "N"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + oTransform(self[i]) )
        ELSEIF xType == "D"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + DTOC(self[i]))
        ELSEIF xType == "B"
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + "{ || ... }" )
        ELSE
             AADD( aClass,  padr(oObj:IVars[i,1],20," ") + oTransform( self[i] )  )
        ENDIF
     ELSE
         AADD( aClass, padr(oObj:IVars[i,1],20," ") + "<NIL>"  )
     ENDIF

NEXT
AADD( aClass,  replicate("-",70)  )
AADD( aClass,  PADR("CLASS METHODS ("+Alltrim(str(len(oObj:Methods)))+")",20 ) )
AADD( aClass,  replicate("-",70) )

FOR i=1 TO LEN( oObj:Methods )
         AADD( aClass, padr(oObj:Methods[i,1],20," ")+ padr(oObj:Methods[i,2]+"()",20," ")  )
NEXT

DISPBOX( 1, 1, MAXROW()-1, MAXCOL()-10, B_DOUBLE + " " )
DispOutAt( 1,26," CLASS INFO ", "B/BG" )
BOXSHADOW( 1, 1, MAXROW()-1, MAXCOL()-10 )
ACHOICE( 2, 2, MAXROW()-2, Maxcol()-11, aClass )

RestScreen(,,,,aSave[5] )
SetPos( aSave[1], aSave[2] )
SetCursor( aSave[3] )
SetColor( aSave[4] )

RETURN ( self )



/*---------------------------------------------------------------------------*/
//                         OBJECT UTILITIES
/*---------------------------------------------------------------------------*/

// ->
// -> Support for inheritance of native classes
// -> Each ::Super METHOD Message is filtered through this unique METHOD
// -> This way we save some IVar space and also have a uniform call to
// -> ::super METHODs
// ->
// -> CallingMsg() is PROCNAME(0) that returns "obj:<message>", so, the
// -> obj: code block argument is provided automatically.
// ->
//
METHOD __SuperMethod( p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15 )
//
Local xVal, cBlock
IF PCount() == 0
     cBlock := "{|obj|"+CallingMsg()+"()}"
ELSE
     cBlock := "{|obj,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15|"+CallingMsg()+"(p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15 )}"
ENDIF
RETURN ( xVal := EVAL( &(cBlock),::Super,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15  ) )


// ->
// -> Support for inheritance of native classes
// ->
//
STATIC FUNCTION __BSupMethods( cMeth )
Local bBlock
RETURN &("{|o,a,b,c,d,e,f,g,h,i,j,oS| oS := __GetSuper(o), oS:"+cMeth+"(a,b,c,d,e,f,g,h,i,j) }")

//
STATIC FUNCTION __BSupIVars( cIVar )
Local bBlock
RETURN &("{|o, xVal, oS| oS:=__GetSuper(o), IF( xVal == NIL, oS:"+cIVar+", oS:_"+cIVar+"(xVal) ) }")

//
FUNCTION __GetSuper( o )
RETURN IF( o:Dict:Super == NIL, o, o:Dict:Super )


// ->
// -> Send Message <cMsg> with parameters p1-p5 to every object in
// -> <aArray>. Assumes every element is an object and they all contain
// -> message <cMsg>
// ->
//
FUNCTION ASend( aArray, cMsg, p1, p2, p3, p4, p5 )
local i
FOR i=1 TO LEN( aArray )
     EVAL( &("{|o,a,b,c,d,e| o:"+cMsg+"(a,b,c,d,e) }"), aArray[i], p1, p2, p3, p4, p5 )
NEXT
RETURN aArray


// ->
// -> RETURN the value of an object's IVAR
// ->
/*---------------------------------------------------------------------------*/
Function OGETDATA( oObject, cIVar )
/*---------------------------------------------------------------------------*/
RETURN ( eval( &( "{ | o | o:" + cIVar + "}" ), oObject ) )


// ->
// -> Set the value of an object's IVAR
// ->
/*---------------------------------------------------------------------------*/
Function OSETDATA( oObject, cIVar, xValue )
/*---------------------------------------------------------------------------*/
eval(&("{ | o, x | o:_" + cIVar + "( x ) }"), oObject, xValue)
RETURN ( Nil )


// ->
// -> Replicate an object and all its sub objects (Reentrant function)
// ->
/*---------------------------------------------------------------------------*/
Function OOCLONE(oObject)
/*---------------------------------------------------------------------------*/
Local oNew, i

If (ISOBJECT(oObject))
    oNew:= __classins(oObject:classh())
    asize(oNew, Len(oObject))
Else
    oNew:= array(Len(oObject))
EndIf

ACopy( oObject, oNew )

For i:= 1 To Len(oNew)
    If (ValType(oNew[i]) $ "AO")
        oNew[i]:= ooclone(oObject[i])
    EndIf
Next

RETURN ( oNew )

// ->
// -> RETURN an array of Class IVars
// ->
/*---------------------------------------------------------------------------*/
FUNCTION aoData( oObject )
/*---------------------------------------------------------------------------*/
   local aInfo  := ASort( __ClassSel( oObject:ClassH() ) )
   local aData  := {}
   local i      := 1
   local lExact := Set( _SET_EXACT, .t. )

   while SubStr( aInfo[i], 1, 1 ) != "_"
      if ASCAN( aInfo, "_" + SubStr( aInfo[i], 1, 9 ), i+1 ) != 0
         AAdd( aData, aInfo[i] )
      endif
      i++
   end

   Set( _SET_EXACT, lExact )

RETURN aData


// ->
// -> RETURN an array of Class Methods
// ->
/*---------------------------------------------------------------------------*/
FUNCTION aoMethods( oObject )
/*---------------------------------------------------------------------------*/
   local aInfo  := ASort( __ClassSel( oObject:ClassH() ) )
   local aData  := {}
   local i      := 1
   local lExact := Set( _SET_EXACT, .t. )

   while SubStr( aInfo[i], 1, 1 ) != "_"
      if ASCAN( aInfo, "_" + SubStr( aInfo[i], 1, 9 ), i+1 ) == 0
         AAdd( aData, aInfo[i] )
      endif
      i++
   end

   Set( _SET_EXACT, lExact )

RETURN aData


// ->
// -> Get the value of an Instance Variable
// ->
/*---------------------------------------------------------------------------*/
Static Function IVAREVAL( o, cName, val )
/*---------------------------------------------------------------------------*/
Local cVarName, xVarRet
      If (PCount() == 3)
          cVarName:= "o:_" + cName + "( val )"
      Else
          cVarName:= "o:" + cName
      EndIf
      Begin Sequence
          xVarRet:= &cVarName
      Recover
          alert("Error in IVarEVal(): " + cName)
          xVarRet:= Nil
      End Sequence
RETURN xVarRet


// ->
// -> convert any datatype to string
// ->
/*---------------------------------------------------------------------------*/
Static Function oTRANSFORM(xVal)
/*---------------------------------------------------------------------------*/
    Local cType:= ValType(xVal)

    Do Case
    Case cType == "C"
        RETURN '"' + xVal + '"'
    Case cType == "N"
        RETURN LTrim(Str(xVal))
    Case cType == "D"
        RETURN "CTOD('" + DToC(xVal) + "')"
    Case cType == "A"
        RETURN "{ ... }"
    Case cType == "B"
        RETURN "{ || ... }"
    Case cType == "L"
        RETURN IIf(xVal, ".T.", ".F.")
    Case cType == "M"
        RETURN "Memo"
    Case cType == "O"
        RETURN "Object"
    EndCase
    RETURN "NIL"
RETURN NIL



// ->
// -> Double Line BoxShadow... Used by ::classInfo()
// ->
/*---------------------------------------------------------------------------*/
STATIC FUNCTION BoxShadow( nTop, nLeft, nBottom, nRight, nColor )
/*---------------------------------------------------------------------------*/
   Local cOldColor :=SetColor()
   LOCAL nShadTop
   LOCAL nShadLeft
   LOCAL nShadBottom
   LOCAL nShadRight
   DEFAULT nColor To 8
   
   nShadTop   := nShadBottom := MIN( nBottom + 1, MAXROW() )
   nShadLeft  := nLeft + 2
   nShadRight := MIN( nRight + 1, MAXCOL() )
   DispBegin()
   RESTSCREEN( nShadTop, nShadLeft, nShadBottom, nShadRight+1,                 ;
      TRANSFORM( SAVESCREEN(nShadTop, nShadLeft, nShadBottom, nShadRight+1),   ;
      REPLICATE("X"+chr(nColor)+"X"+chr(nColor), nShadRight - nShadLeft + 1 ) ) )

   nShadTop    := nTop + 1
   nShadLeft   := nShadRight := MIN( nRight + 1, MAXCOL() )
   nShadBottom := nBottom

   RESTSCREEN( nShadTop, nShadLeft, nShadBottom, nShadRight+1,                 ;
      TRANSFORM( SAVESCREEN(nShadTop,  nShadLeft, nShadBottom,  nShadRight+1), ;
      REPLICATE("X"+chr(nColor)+"X"+chr(nColor), nShadBottom - nShadTop + 1 ) ) )
   DispEnd()
   SetColor( cOldColor )
   RETURN ( NIL )


//
PROCEDURE __bAddCls( bClass, bSuper )
//
AADD( saClasses, { bClass, bSuper } )
RETURN


//
PROCEDURE InitClasses()
//
LOCAL i
   FOR i=1 TO LEN( saClasses )
     EVAL( saClasses[i,1] )
   NEXT
RETURN


