#include "clipoo.ch"
#include "common.ch"
#include "Box.ch"

#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  <uVar1> := If( <uVar1> == nil, <uVal1>, <uVar1> ) ;;
                [ <uVarN> := If( <uVarN> == nil, <uValN>, <uVarN> ); ]

#xcommand DEFAULT <v1> TO <x1> [, <vn> TO <xn> ]                        ;
          =>                                                            ;
          IF <v1> == NIL ; <v1> := <x1> ; END                           ;
          [; IF <vn> == NIL ; <vn> := <xn> ; END ]

//-------------------------- CLASS _OBJECT_ ---------------------------------//


#xTranslate CallingMsg()  => PROCNAME(0)

// -> Declare _OBJECT_ Class Instance variables
// -> as QSelf() array elements

#define O_NAME           QSelf()[1]
#define O_IVARS          QSelf()[2]
#define O_METHODS        QSelf()[3]
#define O_HANDLE         QSelf()[4]
#define O_NEWOBJ         QSelf()[5]
#define O_SUPER          QSelf()[6]
#define O_SCOPE          QSelf()[7]
#define O_ALIAS          QSelf()[8]
#define O_BSUPER         QSelf()[9]
#define O_NELEM          QSelf()[10] // current self element added
#define O_NMELEM         QSelf()[11] // current self element added

//-------------------------- OOBJECT ARRAYS ---------------------------------//

#define M_NAME         1
#define M_FUNC         2
#define M_ALIAS        3
#define M_SCOPE        4       // NEW: Method Scoping

#define IV_NAME         1      // IVars array
#define IV_FUNC         2      // IVar Code Block
#define IV_DATA         3      // IVar default data or NIL
#define IV_SCOPE        4      // IVar scope
#define IV_LINKMETH     5      // IVar string of Linked Method
#define IV_DATAPOS      6      // IVar pos in self[] table
#define IV_ALIAS        7      // IVar Alias

#define IV_ACCESS       1      // Access Assign Array element 1
#define IV_ASSIGN       2      // Access Assign Array element 2

#define IV_BLOCK        IV_FUNC
#define IV_ATTRIB       IV_SCOPE


//-------------------------- SCOPE DEFINITIONS ------------------------------//

#define SCOPE_EXPORT        0
#define SCOPE_HIDDEN        1
#define SCOPE_VIRTUAL       2
#define SCOPE_ACCESS        3
#define SCOPE_READONLY      4
#define SCOPE_CONSTRUCTOR   5

#define SCOPE_PROTECTED SCOPE_READONLY
#define SCOPE_PRIVATE   SCOPE_HIDDEN
#define SCOPE_LOCAL     SCOPE_HIDDEN

